hdu 4472 Count【思维+dp】好题

Count

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2330    Accepted Submission(s): 1554

Problem Description

Prof. Tigris is the head of an archaeological team who is currently in charge of an excavation in a site of ancient relics.
This site contains relics of a village where civilization once flourished. One night, examining a writing record, you find some text meaningful to you. It reads as follows.
“Our village is of glory and harmony. Our relationships are constructed in such a way that everyone except the village headman has exactly one direct boss and nobody will be the boss of himself, the boss of boss of himself, etc. Everyone expect the headman is considered as his boss’s subordinate. We call it relationship configuration. The village headman is at level 0, his subordinates are at level 1, and his subordinates’ subordinates are at level 2, etc. Our relationship configuration is harmonious because all people at same level have the same number of subordinates. Therefore our relationship is …”
The record ends here. Prof. Tigris now wonder how many different harmonious relationship configurations can exist. He only cares about the holistic shape of configuration, so two configurations are considered identical if and only if there’s a bijection of n people that transforms one configuration into another one.
Please see the illustrations below for explanation when n = 2 and n = 4.


The result might be very large, so you should take module operation with modules 109 +7 before print your answer. 

Input

There are several test cases.
For each test case there is a single line containing only one integer n (1 ≤ n ≤ 1000).
Input is terminated by EOF.

Output

For each test case, output one line “Case X: Y” where X is the test case number (starting from 1) and Y is the desired answer.

Sample Input

1

2

3

40

50

600

700

Sample Output

Case 1: 1

Case 2: 1

Case 3: 2

Case 4: 924

Case 5: 1998

Case 6: 315478277

Case 7: 825219749

Source

2012 Asia Chengdu Regional Contest

Recommend

liuyiding   |   We have carefully selected several similar problems for you:  5906 5905 5903 5902 5901 

 

题目大意:

给你N个点,让你求一共有多少个符合下列条件的树:

要求level 0只有一个点,其下列每一层节点的子节点的个数要求相同。


思路:


1、首先我们可以去掉level0的那个点,那么剩下n-1个点构成森林,要求森林中的每颗树的节点数和形状都要相同。


2、那么既然要求每颗树的节点数要相同,那么假设我们有M棵树,每颗数有K个节点,那么M*K==n-1,也就是说这个K,需要是n-1的因子数才行。

那么我们设定a【i】表示节点数为i的一颗树有多少种建立的方法,那么不难想到其状态转移方程:

dp【i】=dp【i】+dp【j】【if(i-1)%j==0】(level0还有一个节点)


Ac代码:

#include<stdio.h>
#include<string.h>
using namespace std;
#define ll __int64
const ll mod=1e9+7;
long long int  dp[50000];
void init()
{
    for (int i = 1; i < 1005; i++) dp[i] = 1;
    for (int i = 3; i < 1005; i++)
    {
        for (int j = 2; j < i; j++)
        {
            if ((i-1)%j==0)
            {
                dp[i]+=dp[j];
                dp[i]%=mod;
            }
        }
    }
}
int main()
{
    int n;
    init();
    int kase=0;
    while(~scanf("%d",&n))
    {
        printf("Case %d: ",++kase);
        printf("%I64d\n",dp[n]);
    }
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值